'use strict';
var newGroupArray = [];

function handleClick(userid) {
    if (newGroupArray.length > 0) {
        if (newGroupArray.indexOf(userid) == -1) {
            newGroupArray.push(userid);
        }
        else {
            var index = newGroupArray.indexOf(userid);
            newGroupArray.splice(index, 1);
        }
    }
    else {
        newGroupArray.push(userid);
    }
}

function createGroup() {
    Appyscript.showIndicator();
    var groupName = $$('#groupname').val();
    if (newGroupArray.length <= 0) {
        Appyscript.hideIndicator();
        Appyscript.alert(AppyTemplate.global.pageLanguageSetting.Messenger_Select_Atlest_One_User, appnameglobal_allpages);
        return;
    }
    if (groupName.trim() == "" || groupName.trim() == null) {
        Appyscript.hideIndicator();
        Appyscript.alert(AppyTemplate.global.pageLanguageSetting.Messenger_Enter_Group_Name, appnameglobal_allpages);
        return;
    }
    if (newGroupArray.length > 10) {
        Appyscript.hideIndicator();
        Appyscript.alert(AppyTemplate.global.pageLanguageSetting.Messenger_Sorry_We_Cannot_Provide_More_Than_10_User, appnameglobal_allpages);
    }
    getGroupId().then(function (data) {
        createGroupFirebase(data, newGroupArray, groupName);
    }, function (error) {
        Appyscript.hideIndicator();
        Appyscript.alert(something_went_wrong_please_try_again, appnameglobal_allpages);
    });
}

function createGroupFirebase(groupId, newGroupArray, groupname) {
    var groupsData = {};
    groupsData.user = {};
    for (var i = 0; i < newGroupArray.length; i++) {
        groupsData.user[newGroupArray[i]] = 0;
    }
    groupsData.user[userId] = 0;
    groupsData.name = groupname;
    groupsData.profilepic = "";
    groupsData.admin = userId;
    groupsData.countUser = newGroupArray.length + 1;
    var userGroupData = {};
    userGroupData[groupId] = 0;
    messengerFirebase.database().ref("/groups/" + groupId).set(groupsData, function (groupError) {
        if (groupError) {
            Appyscript.hideIndicator();
            Appyscript.alert(something_went_wrong_please_try_again, appnameglobal_allpages);
        }
        else {
            for (var i = 0; i < newGroupArray.length; i++) {
                updateUserGroup(newGroupArray[i], groupId, groupsData).then(function (data) {}, function (error) {})
            }
            updateUserGroup(userId, groupId, groupsData).then(function (data) {}, function (error) {})
            openGroup(groupId, groupname);
            Appyscript.hideIndicator();
            var currentUserName = JSON.parse(localStorage.getItem("userdata")).data.name;
            var message = currentUserName + " " + AppyTemplate.global.pageLanguageSetting.Messenger_Create_A_New_Group;
            for (var i = 0; i < newGroupArray.length; i++) {
                addNotification("notification/" + newGroupArray[i], "group", groupsData, groupId, userId, currentUserName, message);
                newGroupArray = [];
            }
        }
    });
}

function updateUserGroup(userid, groupId, groupsData) {
    return new Promise(function (resolve, reject) {
        messengerFirebase.database().ref("/userGroups/" + userid + "/" + groupId).set(groupsData, function (userGroupError) {
            if (userGroupError) {
                reject("error");
            }
            else {
                resolve("sucess");
            }
        });
    });
}

function getGroupId() {
    return new Promise(function (resolve, reject) {
        var currentGroupId = messengerFirebase.database().ref('groups/groupMaxId');
        currentGroupId.transaction(function (current_value) {
            if (current_value === null) {
                return "g" + 1;
            }
            else {
                var splitArray = current_value.split("g");
                var newValue = parseInt(splitArray[1]) + 1;
                return "g" + newValue;
            }
        }, function (error, committed, snapshot) {
            if (error) {
                reject("Trascation failed");
            }
            else if (!committed) {
                reject("Trascation aborted");
            }
            else {
                resolve(snapshot.val());
            }
        });
    });
}

function openGroup(groupId, groupname, context) {
    if (messengerpageData.groupData) {
        for (var i = 0; i < messengerpageData.groupData.length; i++) {
            if (messengerpageData.groupData[i].groupId == groupId) {
                messengerpageData.groupData[i].unread = 0;
            }
        }
    }
    chatid = groupId;
    isBlockUser = false;
    $$.getJSON('res/emoji.json', function (emoji) {
        messengerpageData.emoji = emoji;
        var emojiData = {}
        emojiData.emoji = messengerpageData.emoji;
        Appyscript.showIndicator();
        currentChatUser = false;
        messengerFirebase.database().ref('groupDetail/' + groupId).once('value', function (messageSnapshot) {
            var localUserData = JSON.parse(localStorage.getItem("userdata"));
            var messageArray = {
                "name": localUserData.data.name
                , "profilepic": localUserData.data.profilepic
                , "phoneno": localUserData.data.phoneno
                , "userid": localUserData.userid
                , "groupname": groupname
                , "groupid": groupId
            };
            var localMessageArray = [];
            messageSnapshot.forEach(function (innerMessageSnapshot) {
                localMessageArray.push(innerMessageSnapshot.val());
            });
            localMessageArray = localMessageArray.reverse();
            var sortMessageArray = sortArrayAccordingDate(localMessageArray);
            messageArray.message = sortMessageArray;
            chatType = "group";
            if ($$(context).find(".item-media").find("span")) {
                $$(context).find(".item-media").find("span").remove();
            }
            messageArray.emoji = messengerpageData.emoji;
            $$.get("pages/messenger-message.html", function (template) {
                var compiledTemplate = AppyTemplate.compile(template);
                var html = compiledTemplate(messageArray);
                mainView.router.load({
                    content: html
                    , animatePages: true
                });
                $$('#medialoader').hide();
                var myMessages = Appyscript.messages('.messages', {
                    autoLayout: true
                });
                Appyscript.hideIndicator();
            });
        });
    });
    var unreadData = {};
    unreadData[userId] = 0;
    messengerFirebase.database().ref('groups/' + groupId + "/user").update(unreadData);
    messengerFirebase.database().ref('groupDetail/' + groupId).off('child_added');
    messengerFirebase.database().ref('groupDetail/' + groupId).limitToLast(1).on('child_added', function (snap) {
                                                                                 var uniqueId = makeid();
        if (snap.val().from == userId) {}
        else {
            var data = "";
            if (snap.val().type == "Map") {
                data = '<p class="phonenochat">\' ' + snap.val().name + ' \'</p><img src="https://maps.googleapis.com/maps/api/staticmap?zoom=13&size=250x250&maptype=roadmap&markers=color:blue%7Clabel:S%7C' + snap.val().extra.lat + ',%20' + snap.val().extra.lng + '&key=AIzaSyA779DVaviC6nrz4FqyJMR0N4FN_wLd1Vg" onclick="openLargeMapFromChat(' + snap.val().extra.lat + ',' + snap.val().extra.lng + ')">';
            }
            else if (snap.val().type == "Image") {
                data = '<p class="phonenochat">\' ' + snap.val().name + ' \'</p><div id='+uniqueId+' onclick="openImageViewModal(\' '+ snap.val().link.trim() +' \');" style="background:url('+snap.val().link+')"  class="chatinnerimage"></div>';
            }
            else if (snap.val().type == "Video") {
                data = '<p class="phonenochat">\' ' + snap.val().name + ' \'</p> <div id='+uniqueId+'   onclick="openVideoViewModal(\' ' + snap.val().link + ' \');"  style="background:url(' + snap.val().extra.imageurl.trim() + ')" class="chatinnerimage"></div>';
                                                                                 
            }
            else if (snap.val().type == "Audio") {
                data = '<p class="phonenochat">\' ' + snap.val().name + '\'</p><i onclick="openVideoViewModal(\' ' + snap.val().link + '\');" class="iconz-audio lightorange padding40"  aria-hidden="true"></i>';
            }
            else {
                data = '<p class="phonenochat">' + snap.val().name + '</p>' + snap.val().content;
            }
            appendMessage(data, "received",uniqueId,snap.val().type);
            $$("#spanunread" + groupId).remove();
            if (messengerpageData.groupData) {
                for (var i = 0; i < messengerpageData.groupData.length; i++) {
                    if (messengerpageData.groupData[i].groupId == groupId) {
                        messengerpageData.groupData[i].unread = 0;
                        messengerpageData.groupData[i].date = "" + new Date();
                        messengerpageData.groupData[i].message = snap.val().message;
                    }
                }
            }
        }
    });
    //    messengerFirebase.database().ref('groups').on('child_removed', function (snap) {
    //        console.log(snap.val());
    //        console.log(snap.getKey());
    //        if (snap.getKey() == groupId) {
    //            if (!currentChatUser) {
    //                Appyscript.alert("This Group no longer exsit go to main page", appnameglobal_allpages);
    //                mainView.router.back({
    //                    "url": "chat-home"
    //                });
    //            }
    //            else {
    //                currentChatUser = false;
    //            }
    //        }
    //    }, function (error) {})
}
var groupDatam = {};

function loadGroupList(groupArray) {
    groupDatam = groupArray;
    var groupData = {};
    groupData.groupArray = groupArray;
    $$.get("pages/messenger-group-list.html", function (template) {
        var compiledTemplate = AppyTemplate.compile(template);
        var html = compiledTemplate(groupData);
        mainView.router.load({
            content: html
            , animatePages: true
        });
    });
}

function openGroupsList() {
    messengerFirebase.database().ref('userGroups/' + userId).once('value', function (snapshot) {
        var groupArray = [];
        getGroupData(snapshot.val()).then(function (groupData) {
            groupArray = groupData;
            loadGroupList(groupArray);
        }, function (error1) {
            Appyscript.hideIndicator();
            Appyscript.alert(something_went_wrong_please_try_again, appnameglobal_allpages);
        });
    }, function (error) {
        Appyscript.hideIndicator();
        Appyscript.alert(something_went_wrong_please_try_again, appnameglobal_allpages);
    });
}

function openGroupDetail(groupId) {
    messengerFirebase.database().ref('groups/' + groupId).once('value', function (groupSnapshot) {
        var userLength = getActualLength(groupSnapshot.val().user);
        var members = [];
        var count = 0;
        groupSnapshot.forEach(function (innerGroupSnapshot) {
            if (innerGroupSnapshot.getKey() == "user") {
                innerGroupSnapshot.forEach(function (innerUserSnapshot) {
                    getUserData(innerUserSnapshot.getKey()).then(function (data) {
                        data.userId = innerUserSnapshot.getKey();
                        members.push(data);
                        count++;
                        if (count == userLength) {
                            loadGroupDetailPage(groupSnapshot.val(), groupId, members)
                        }
                    }, function (error) {});
                })
            }
        });
    })
}

function loadGroupDetailPage(data, groupId, members) {
    var groupDetailData = {};
    groupDetailData.data = data;
    groupDetailData.groupId = groupId;
    groupDetailData.members = members;
    groupDetailData.firstletter = data.name.charAt(0).toUpperCase();
    $$.get("pages/messenger-group-groupdetail.html", function (template) {
        var compiledTemplate = AppyTemplate.compile(template);
        var html = compiledTemplate(groupDetailData);
        mainView.router.load({
            content: html
            , animatePages: true
        });
    });
}

function deleteGroup(groupId) {
    Appyscript.showIndicator();
    deleteGroupFromUser(userId, groupId).then(function (sucess) {
        for (var i = 0; i < messengerpageData.groupData.length; i++) {
            if (messengerpageData.groupData[i].groupId == groupId) {
                messengerpageData.groupData.splice(i, 1);
            }
            else {}
        }
        Appyscript.hideIndicator();
        getAllMessage(appendUserData, false);
        getAllMessageArray();
        messengerpageData.allMessage.sort(filterByDate);
        setTimeout(function () {
            $$.get("pages/messenger-home.html", function (template) {
                var compiledTemplate = AppyTemplate.compile(template);
                var html = compiledTemplate(messengerpageData);
                mainView.router.reloadContent(html);
                appendUserData = [];
            });
        }, 1000);
    }, function (error) {
        Appyscript.hideIndicator();
        Appyscript.alert(something_went_wrong_please_try_again, appnameglobal_allpages);
    })
}

function deleteGroupFromUser(userid, groupId) {
    return new Promise(function (resolve, reject) {
        messengerFirebase.database().ref("userGroups/" + userid + "/" + groupId).remove(function (userGroupError) {
            if (userGroupError) {
                reject("error");
            }
            else {
                resolve("sucess");
            }
        });
    });
}

function deleteGroupDetail(groupId) {
    currentChatUser = true;
    Appyscript.hideIndicator();
    messengerFirebase.database().ref('groups/' + groupId).remove(function (groupsError) {
        if (groupsError) {}
        else {
            messengerFirebase.database().ref('groups/' + groupId).remove(function (groupsDetailError) {
                if (groupsDetailError) {}
                else {}
            });
        }
    });
}

function Promise(fn) {
    var state = 'pending';
    var value;
    var deferred = null;

    function resolve(newValue) {
        if (newValue && typeof newValue.then === 'function') {
            newValue.then(resolve, reject);
            return;
        }
        state = 'resolved';
        value = newValue;
        if (deferred) {
            handle(deferred);
        }
    }

    function reject(reason) {
        state = 'rejected';
        value = reason;
        if (deferred) {
            handle(deferred);
        }
    }

    function handle(handler) {
        if (state === 'pending') {
            deferred = handler;
            return;
        }
        var handlerCallback;
        if (state === 'resolved') {
            handlerCallback = handler.onResolved;
        }
        else {
            handlerCallback = handler.onRejected;
        }
        if (!handlerCallback) {
            if (state === 'resolved') {
                handler.resolve(value);
            }
            else {
                handler.reject(value);
            }
            return;
        }
        var ret = handlerCallback(value);
        handler.resolve(ret);
    }
    this.then = function (onResolved, onRejected) {
        return new Promise(function (resolve, reject) {
            handle({
                onResolved: onResolved
                , onRejected: onRejected
                , resolve: resolve
                , reject: reject
            });
        });
    };
    fn(resolve, reject);
}

function addNotification(refString, type, object, id, from, name, message) {
    var currentTime = "" + new Date();
    var notificationData = {
        "message": message
        , "type": type
        , "object": object
        , "id": id
        , from: from
        , "name": name
        , "time": currentTime
    }
    messengerFirebase.database().ref(refString).push(notificationData);
}

function deleteNotification(key) {
    messengerFirebase.database().ref("notification/" + userId + "/" + key).remove();
}

function openPageFromNotification(type,key,context) {
    Appyscript.showIndicator();
    deleteNotification(key);
    switch (type) {
    case "send":
        openPendingRequestPage();
        break;
    case "accept":
        openMyContactPage("");
        break;
    case "group":
        openGroupsList();
        break;
    default:
        break
    }
 $$(context).parents(".close-popup").remove();
}